<template>
  <div class="search">
    <JTextField
      placeholder="Search by name, email"
      name="search"
      class="search-input"
    >
      <template #prepend>
        <JIcon
          icon="search"
          container-size
          icon-wrapper
          size="16px"
          border-radius="0px"
        />
      </template>
    </JTextField>
  </div>

  <template v-if="multiSelect">
    <div class="selected-users-wrapper">
      <JChip
        v-for="user in selectedUsers"
        :key="user.id"
        closable
        @remove="onSelectUser(user)"
      >
        <UserChatCard
          :user="user"
          hide-status
          size="small"
        />
      </JChip>
    </div>
    <JKeyboardNavByFocus>
      <JScrollbarContainer>
        <JScrollbarViewport
          ref="scrollViewportRef"
          class="scrollbar-viewport"
          @scroll="onViewportScroll"
        >
          <SelectUserList
            ref="scrollContentRef"
            :selected-users="selectedUsers"
            :users="users"
            @select="onSelectUser"
          />
        </JScrollbarViewport>

        <JScrollbarTrack
          hide-track
          hide-thumb
        />
      </JScrollbarContainer>
    </JKeyboardNavByFocus>
  </template>

  <JKeyboardNavByFocus v-else>
    <JScrollbarContainer>
      <JScrollbarViewport
        ref="scrollViewportRef"
        class="scrollbar-viewport"
        @scroll="onViewportScroll"
      >
        <JList ref="scrollContentRef">
          <JKeyboardNavItem
            v-for="user in users"
            :key="user.id"
            #default="a11yProps"
          >
            <JListItem
              v-bind="a11yProps"
              size="xl"
              @keydown.space.prevent="$emit('select:single', user)"
              @keydown.enter="$emit('select:single', user)"
              @click="$emit('select:single', user)"
            >
              <UserChatCard :user="user" />
            </JListItem>
          </JKeyboardNavItem>
        </JList>
      </JScrollbarViewport>

      <JScrollbarTrack
        hide-track
        hide-thumb
      />
    </JScrollbarContainer>
  </JKeyboardNavByFocus>
</template>

<script setup lang="ts">
import {
  computed, nextTick, onMounted, ref, watch,
} from 'vue';
import { storeToRefs } from 'pinia';
import {
  JIcon,
  JChip,
  JList,
  JListItem,
  JTextField,
  JKeyboardNavItem,
  JKeyboardNavByFocus,
} from '@new-jira-clone/ui/src/components';
import {
  useCustomScrollbar,
  JScrollbarTrack,
  JScrollbarViewport,
  JScrollbarContainer,
} from '@new-jira-clone/ui/src/components/shared/JScrollbar';
import { useUserStore } from '@new-jira-clone/libs/src/store';
import { SelectUserList, UserChatCard } from '@/entities/User';
import { useUsersListSocket } from '@/shared/api';
import { IUser } from '@/shared';
import { useUsersListStore } from '@/shared/model/store/useUsersListStore';

const props = defineProps({
  multiSelect: {
    type: Boolean,
    default: true,
  },
});

const emits = defineEmits<{
  (event: 'select:single', users: IUser): void;
  (event: 'select:multiple', user: IUser[]): void;
}>();

const { getUser } = storeToRefs(useUserStore());
const { listUsers } = storeToRefs(useUsersListStore());

const { getListUsers } = useUsersListSocket();
const { initScrollbar, onViewportScroll } = useCustomScrollbar();

const scrollViewportRef = ref<HTMLElement | null>(null);
const scrollContentRef = ref<HTMLElement | null>(null);

const selectedUsers = ref<IUser[]>([]);

const onSelectUser = (selectedUser: IUser) => {
  const isExistUser = selectedUsers.value.find((user) => user.id === selectedUser.id);

  if (isExistUser) {
    selectedUsers.value = selectedUsers.value.filter((user) => user.id !== selectedUser.id);
  } else {
    selectedUsers.value.push(selectedUser);
  }

  emits('select:multiple', selectedUsers.value);
};

getListUsers();

const users = computed(() => {
  if (listUsers.value.length === 0) return [];

  return listUsers.value.filter((user: IUser) => user.id !== getUser.value.id);
});

onMounted(async () => {
  await nextTick();

  requestIdleCallback(() => {
    if (scrollViewportRef.value && scrollContentRef.value) {
      initScrollbar(scrollViewportRef.value, scrollContentRef.value);
    }
  });
});

watch(() => props.multiSelect, async () => {
  await nextTick();

  requestIdleCallback(() => {
    if (scrollViewportRef.value && scrollContentRef.value) {
      initScrollbar(scrollViewportRef.value, scrollContentRef.value);
    }
  });
});
</script>

<style lang="scss" scoped>
.selected-users-wrapper {
  display: flex;
  flex-wrap: wrap;
  padding: 6px;
  gap: 4px;
}

.scrollbar-viewport {
  max-height: max-content;
}
</style>
